/*
Triggers Tesla Coil to turn on when someone passes by
Created by Devin Lieberman
Version 1.0
9/26/09
Copyright (C) 2009 Devin Lieberman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
    
*/

#include "WProgram.h"
void setup();
void loop();
void sonarSetup();
int sonarAnalog();
int sonarPulseWidth();
int relay = 13;
unsigned long time = 0;

void setup()
{
  Serial.begin(9600);
  sonarSetup();
  pinMode(relay, OUTPUT);
  delay(2000);
}

void loop()
{
  int distance = sonarPulseWidth();
  Serial.println(distance);
  if(distance < 50 && (time + 15000) < millis())
  {
    digitalWrite(relay, HIGH);
    delay(500);
    digitalWrite(relay, LOW);
    time = millis();
  }
}
/*
Sonar Sensor Library for MaxBotix  MAxSonar EZ1 (MB1010)
Created by Devin Lieberman
Version 1.0
9/26/09
Copyright (C) 2009 Devin Lieberman

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    aint with this program.  If not, see <http://www.gnu.org/licenses/>
    
*/
                         //Sonar GND to ground
                         //Sonar +5 to +5
                         //Sonar TX -- Useless
int sonarRX    = 3;      //Sonar RX to digital pin 3, HIGH for data LOW to turn off, wait 20uS before reading again
int sonarAN    = 4;      //Sonar AN to digital pin 4, Vcc/512 per inch, ~9.8mV/in for +5V
int sonarPW    = 5;      //Sonar PW to digital pin 5, 147uS per inch (2.54cm/in)
                         //Sonar BW -- Useless

void sonarSetup()
{
  pinMode(sonarRX, OUTPUT);
  pinMode(sonarAN, INPUT);
  pinMode(sonarPW, INPUT);
}

int sonarAnalog()
{
  return (analogRead(sonarAN) * 2.54);
}

int sonarPulseWidth()
{
  return ((pulseIn(sonarPW, HIGH) / 147) * 2.54);
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

