/*
Triggers Tesla Coil to turn on when someone passes by
Created by Devin Lieberman
Version 2.0
9/26/09
Copyright (C) 2009 Devin Lieberman

    This work is licensed under a Creative Commons
    Attribution-Noncommercial-Share Alike 3.0 Unported
    License. See http://creativecommons.org/licenses/by-nc-sa/3.0/
    for more information.
    
    Please use the following as credit to the original author for
    any alteration to this work:
    Email: devin@devin.gotdns.com  
    Website: http://devin.gotdns.com/
*/

int transistor = 13;                                 //transistor base to resistor to pin 13
unsigned long time = 0;
int avgdistance = 0;

void setup()
{
  Serial.begin(9600);                                //protip: plug in a serial lcd for quick testing
  sonarSetup();
  pinMode(transistor, OUTPUT);
  delay(2000);                                       //give time for everything to get ready
  for(int i = 0; i <= 30; i++)                       //get an average distance on how far away the other wall is
  {
    avgdistance += sonarPulseWidth();
  }
  avgdistance /= 30;
  avgdistance -= 50;
}

void loop()
{
  int distance = sonarPulseWidth();
  Serial.println(distance);
  if(distance < avgdistance && (time + 90000) < millis())    //distance has to be less than the avgdistance away
                                                             //and can't have been triggered in the past 90 seconds
  {
    digitalWrite(transistor, HIGH);
    delay(500);                                      //turn coil on for 1/2 second
    digitalWrite(transistor, LOW);
    time = millis();
  }
}

